window.__require = function e(t, o, r) {
function n(a, c) {
if (!o[a]) {
if (!t[a]) {
var l = a.split("/");
l = l[l.length - 1];
if (!t[l]) {
var d = "function" == typeof __require && __require;
if (!c && d) return d(l, !0);
if (i) return i(l, !0);
throw new Error("Cannot find module '" + a + "'");
}
a = l;
}
var s = o[a] = {
exports: {}
};
t[a][0].call(s.exports, function(e) {
return n(t[a][1][e] || e);
}, s, s.exports, e, t, o, r);
}
return o[a].exports;
}
for (var i = "function" == typeof __require && __require, a = 0; a < r.length; a++) n(r[a]);
return n;
}({
SceneFireworkController: [ function(e, t, o) {
"use strict";
cc._RF.push(t, "f789cdPVptK4KN1MH0xei/U", "SceneFireworkController");
Object.defineProperty(o, "__esModule", {
value: !0
});
var r = e("../../../Script/Framework/Core/Resource/AssetManager"), n = e("./SceneFirework"), i = cc._decorator, a = i.ccclass, c = i.property, l = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.fireworkPrefabs = [];
t.minFireInterval = 3;
t.maxFireInterval = 5;
t.minFireTime = .5;
t.maxFireTime = 1.5;
t.minHeight = 200;
t.maxHeight = 400;
t.bornPos = new cc.Vec2();
t.nextBornTime = 0;
return t;
}
t.prototype.onEnable = function() {
this.node.removeAllChildren();
};
t.prototype.start = function() {
this.nextBornTime = Math.randomRange(0, 1);
};
t.prototype.update = function(e) {
if (this.nextBornTime > 0) {
this.nextBornTime -= e;
this.nextBornTime <= 0 && this.RebornEntity();
}
};
t.prototype.RebornEntity = function() {
return __awaiter(this, void 0, void 0, function() {
var e, t, o, i, a, c;
return __generator(this, function(l) {
switch (l.label) {
case 0:
e = this.fireworkPrefabs[Math.randomIntBetween(0, this.fireworkPrefabs.length - 1)];
t = this.node.getContentSize();
this.bornPos.x = Math.randomRange(-t.width * this.node.anchorX, t.width * (1 - this.node.anchorX));
this.bornPos.y = Math.randomRange(-t.height * this.node.anchorY, t.height * (1 - this.node.anchorY));
o = Math.randomRange(.8, 1);
return [ 4, r.default.Default.CreateNode(e, this.node, this.bornPos, 0, o) ];

case 1:
i = l.sent();
a = Math.randomRange(this.minFireTime, this.maxFireTime);
c = Math.randomRange(this.minHeight, this.maxHeight);
i.getComponent(n.default).Fire(a, c, !0, function() {});
this.GenerateNextBornTime(this.minFireInterval, this.maxFireInterval);
return [ 2 ];
}
});
});
};
t.prototype.GenerateNextBornTime = function(e, t) {
this.nextBornTime = Math.randomRange(e, t);
};
__decorate([ c({
type: cc.Prefab,
tooltip: "预制件"
}) ], t.prototype, "fireworkPrefabs", void 0);
__decorate([ c({
tooltip: "烟花弹发射最小间隔"
}) ], t.prototype, "minFireInterval", void 0);
__decorate([ c({
tooltip: "烟花发射最大间隔"
}) ], t.prototype, "maxFireInterval", void 0);
__decorate([ c({
tooltip: "烟花弹最小飞行时间"
}) ], t.prototype, "minFireTime", void 0);
__decorate([ c({
tooltip: "烟花弹最大飞行时间"
}) ], t.prototype, "maxFireTime", void 0);
__decorate([ c({
tooltip: "烟花弹最小飞行时间"
}) ], t.prototype, "minHeight", void 0);
__decorate([ c({
tooltip: "烟花弹最大飞行时间"
}) ], t.prototype, "maxHeight", void 0);
return __decorate([ a ], t);
}(cc.Component);
o.default = l;
cc._RF.pop();
}, {
"../../../Script/Framework/Core/Resource/AssetManager": void 0,
"./SceneFirework": "SceneFirework"
} ],
SceneFirework: [ function(e, t, o) {
"use strict";
cc._RF.push(t, "2ed9b7igEpCfbvd9a+WmWg/", "SceneFirework");
Object.defineProperty(o, "__esModule", {
value: !0
});
var r = e("../../../Script/Framework/Core/Resource/SoundsManager"), n = cc._decorator, i = n.ccclass, a = n.property, c = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.bullet = null;
t.animation = null;
t.audioClip = null;
return t;
}
t.prototype.Fire = function(e, t, o, n) {
var i = this;
this.animation.node.enabledAllChild(!1);
this.bullet.active = !0;
var a = this.animation.getClips()[0].duration;
cc.tween(this.node).by(e, {
y: t
}).call(function() {
i.animation.node.enabledAllChild(!0);
i.bullet.active = !1;
i.animation.stop();
i.animation.play();
for (var e = i.animation.node.getComponentsInChildren(cc.ParticleSystem), t = 0; t < e.length; t++) e[t].resetSystem();
o && i.audioClip && r.default.instance.PlayEffect(i.audioClip);
}).delay(a).call(function() {
i.animation.node.enabledAllChild(!1);
n(i.node);
}).start();
};
__decorate([ a(cc.Node) ], t.prototype, "bullet", void 0);
__decorate([ a(cc.Animation) ], t.prototype, "animation", void 0);
__decorate([ a({
type: cc.AudioClip
}) ], t.prototype, "audioClip", void 0);
return __decorate([ i ], t);
}(cc.Component);
o.default = c;
cc._RF.pop();
}, {
"../../../Script/Framework/Core/Resource/SoundsManager": void 0
} ]
}, {}, [ "SceneFirework", "SceneFireworkController" ]);